{
--main Header:
  : array[0..3] of char = 'LFB'$255

  2       size of filecomment max = 64K = 65535 bytes
  X       file comment

--file header:
  bytes     what is
    4       header signature
    2       reserved(version of decompressor needed)
    2       reserved(general propose flag)
    1       os where the file was added
    1       method
    4       compressed size
    4       original size
    4       file's time stamp
    4       file crc-32
    2       filename size
    X       filename (note: the filename is null terminated)
    2       Sizeof extended header

---extended file header
    2       header size
    1       type of header
    X       data      x = Sizeof extended header-2-1
    2       size of next extended header

    The extended header is used to store operating system specific items:
    Atributes,etc

    And finaly the compressed data

    Size = compressed size.


Methods

0x0       =      stored   none
0x1       =      FIN      Super Fast
0x2                       faster
0x3       =      LZAri    normal
0x4       =               best
operating systems

w        =       windows 95/98
W        =       windows NT
D        =       MS-Dos, PC-Dos
U        =       Unix, Linux
2        =       OS/2


}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    compress: TButton;
    ListBox1: TListBox;
    add_to_list: TButton;
    ListView1: TListView;
    OpenDialog1: TOpenDialog;
    list: TButton;
    extract: TButton;
    log: TListBox;
    Pass_Edit: TEdit;
    ComboBox1: TComboBox;
    Test: TButton;
    procedure compressClick(Sender: TObject);
    procedure add_to_listClick(Sender: TObject);
    procedure listClick(Sender: TObject);
    procedure extractClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
type
    FileLocalHeader = packed record
         HeaderSig    : Cardinal;
         Reserved1    : Word;
         Reserved2    : Word;
         OS           : Byte;
         Method       : Byte;
         CompressSize : LongInt;
         OriSize      : LongInt;
         DataTime     : LongInt;
         Crc          : Cardinal;
         FilenameSize : Word;
         Filename     : array[0..255] of Char;
         ExtHeaderSiz : Word;
    end;

var
  Form1: TForm1;
  crctable: array[0..255] of LongInt;
  infile,outfile: file;
  CalCrc: Cardinal;

  Compressing: boolean;

  LocalHeader: FileLocalHeader;

const
     HeaderIdentfy: array[0..3] of char = ('L','F','B',#255);
     FileHeaderSig = $4C46AAFF;       //'LF'+AAFF
     CRC_MASK = $FFFFFFFF;
     DicSize = 32768;//32k

procedure UpdateCrc(var CurrentCrc: Cardinal; NewByte: byte);

implementation

uses lzAri, FIN;

{$R *.DFM}

//Crc code
procedure make_crctable;
var
   i, j: word;
   crc,poly: Cardinal;
begin
     poly := $EDB88320;
     for i := 0 to 255 do
     begin
          crc := i;
          for j := 8 downto 1 do
              begin
                   if (crc and 1) = 1 then
                      crc := (crc shr 1) xor poly
                   else
                       crc := crc shr 1;
              end;
          crctable[i] := crc;
     end;
end;

procedure UpdateCrc(var CurrentCrc: Cardinal; NewByte: byte);
begin
     CurrentCrc := crctable[( Byte(CurrentCrc) xor Byte(NewByte) ) and $ff] xor (CurrentCrc shr{CHAR_BIT}8)
end;

procedure WriteHeader(Temp: Boolean; pos: integer);
var CurFPos: integer;
begin
     if not Temp then CurFPos := FilePos(Outfile);
     Seek(Outfile,Pos);

     //Size of header
     BlockWrite(Outfile,LocalHeader.HeaderSig,4);
     //reseved
     BlockWrite(Outfile,LocalHeader.Reserved1,2);
     //reserved
     BlockWrite(Outfile,LocalHeader.Reserved2,2);
     //operating system
     BlockWrite(Outfile,LocalHeader.OS,1);
     //compress method
     BlockWrite(Outfile,LocalHeader.Method,1);
     //compressed size
     BlockWrite(Outfile, LocalHeader.CompressSize,4);
     //original size
     BlockWrite(Outfile,LocalHeader.OriSize,4);
     //file time
     BlockWrite(Outfile,LocalHeader.DataTime,4);
     //file unpacked crc
     BlockWrite(Outfile,LocalHeader.Crc,4);
     //filename size
     BlockWrite(Outfile,LocalHeader.FilenameSize,2);
     //filename
     BlockWrite(Outfile,LocalHeader.Filename,LocalHeader.FilenameSize);
     //Extended header size
     BlockWrite(Outfile,LocalHeader.ExtHeaderSiz,2);
     //Go to the place we were before starting writing the header
     if not Temp then Seek(Outfile,CurFPos);
end;



procedure Store;
var i: integer;
    Buffer: array[0..DicSize-1] of byte;//32k
   BytesRead,BytesToRead: Cardinal;
begin
     repeat
           if BytesLeft >= DicSize-1 then
              BytesToRead := DicSize-1
           else
               BytesToRead := BytesLeft;

           BlockRead(infile,Buffer,BytesToRead,BytesRead);
           BytesLeft := BytesLeft - BytesRead;

           BlockWrite(outfile,Buffer,BytesRead);

           inc(LocalHeader.CompressSize,BytesRead);

           for i := 0 to BytesRead-1 do
               UpdateCrc(CalCrc,Buffer[i]);
     until BytesLeft <= 0;
end;

procedure UnStore;
var i: integer;
    Buffer: array[0..DicSize-1] of byte;//32k
   BytesRead,BytesToRead: Cardinal;
begin
     repeat
           if BytesLeft >= DicSize-1 then
              BytesToRead := DicSize-1
           else
               BytesToRead := BytesLeft;
           //read the packed bytes
           BlockRead(infile,Buffer,BytesToRead,BytesRead);
           BytesLeft := BytesLeft - BytesRead;
           //write the expanded bytes
           BlockWrite(outfile,Buffer,BytesRead);
           //calc crc
           for i := 0 to BytesRead-1 do
               UpdateCrc(CalCrc,Buffer[i]);
     until BytesLeft <= 0;
end;

procedure TForm1.compressClick(Sender: TObject);
var
   CharIdent: array[0..3] of char;
   CommentSiz: word;
   FPos,i: integer;
   S: string;
begin
     if combobox1.Items.IndexOf(combobox1.Text) = -1 then
        begin
             Log.Items.Add('Invalid compression method');
             Exit;
        end;
     Compressing := true;
     //make the crc table
     make_crctable();
     //create the output file and open it
     AssignFile(outfile,'lzb.lfb');
     Rewrite(outfile,1);

     //write the file main Header
     CharIdent := 'LFB'+#255;
     BlockWrite(Outfile,CharIdent,SizeOf(CharIdent));
     CommentSiz := 0;
     BlockWrite(outfile,CommentSiz,2);


     for i := 0 to ListBox1.Items.Count-1 do
         begin
              try
                AssignFile(infile,ListBox1.Items[i]);
                Reset(infile,1);
                log.Items.Add('Adding: '+ ListBox1.Items[i]);
              except   //if error lets go to next
                 log.Items.Add('Error');
                continue
              end;

              //delete the drive from the filename
              S := ListBox1.Items[i];
              if Pos(':',S) >= 1 then
                 Delete(s,1,Pos(':',S)+1);

              FPos := FilePos(outfile);

              LocalHeader.HeaderSig    := FileHeaderSig;
              LocalHeader.Reserved1    := 0;
              LocalHeader.Reserved2    := 0;
              LocalHeader.OS           := Ord('w');
              LocalHeader.Method       := $00;
              LocalHeader.CompressSize := 0;
              LocalHeader.OriSize      := FileSize(infile);
              LocalHeader.DataTime     := FileAge(ListBox1.Items[i]);;
              LocalHeader.Crc          := 0;
              LocalHeader.FilenameSize := Length(S)+1;//+1 for the #0 char
              StrPCopy(LocalHeader.Filename,S);
              LocalHeader.ExtHeaderSiz := 0;

              //temp header
              WriteHeader(true,FPos);

              //Compress
              CalCrc := CRC_MASK;
              BytesLeft := FileSize(infile);
              case combobox1.Items.IndexOf(combobox1.Text) of
                   0: //stored
                     begin
                          LocalHeader.Method := $00;
                          Store;
                     end;
                   1: //FIN
                     begin
                          LocalHeader.Method := $01;
                          CompressFin;
                     end;
                   2://LzAri
                     begin
                           LocalHeader.Method := $03;
                           EncodeLzAri;
                     end;
              end;


              LocalHeader.Crc := (CalCrc xor CRC_MASK);
              //Real header
              WriteHeader(false,FPos);

              CloseFile(infile);
         end;
     //finally close the output file
     CloseFile(outfile);
end;

procedure TForm1.add_to_listClick(Sender: TObject);
begin
     if OpenDialog1.Execute then
        ListBox1.Items :=  OpenDialog1.Files;

end;

procedure TForm1.listClick(Sender: TObject);
var
   CharIdent: array[0..3] of char;
   ComentSiz: Word;

   ListItem: TListItem;
begin
     ListView1.Items.BeginUpdate;
     ListView1.Items.Clear;
     ListView1.Items.EndUpdate;
     //Make the crc table
     Make_CrcTable;
     AssignFile(infile,'lzb.lfb');
     Reset(infile,1);
     //Read the main Header
     BlockRead(infile,CharIdent,4);
     if CharIdent <> HeaderIdentfy then
        begin
             MessageBox(Handle,'Not a valid LFB file','Error',MB_OK+MB_ICONERROR);
             Exit;
        end;
     BlockRead(infile,ComentSiz,2);
     if ComentSiz > 0 then Seek(Infile,FilePos(infile)+ComentSiz);
     While not Eof(infile) do
     begin
          //Size of header
          BlockRead(infile,LocalHeader.HeaderSig,4);
          //reseved
          BlockRead(infile,LocalHeader.Reserved1,2);
          //reserved
          BlockRead(infile,LocalHeader.Reserved2,2);
          //operating system
          BlockRead(infile,LocalHeader.OS,1);
          //compress method
          BlockRead(infile,LocalHeader.Method,1);
          //compressed size
          BlockRead(infile, LocalHeader.CompressSize,4);
          //original size
          BlockRead(infile,LocalHeader.OriSize,4);
          //file time
          BlockRead(infile,LocalHeader.DataTime,4);
          //file unpacked crc
          BlockRead(infile,LocalHeader.Crc,4);
          //filename size
          BlockRead(infile,LocalHeader.FilenameSize,2);
          //filename
          BlockRead(infile,LocalHeader.Filename,LocalHeader.FilenameSize);
          //Extended header size
          BlockRead(infile,LocalHeader.ExtHeaderSiz,2);
          while LocalHeader.ExtHeaderSiz <> 0 do
          begin
               Seek(infile,FilePos(infile)+LocalHeader.ExtHeaderSiz-2);
               BlockRead(infile,LocalHeader.ExtHeaderSiz,2);
          end;

          ListItem := ListView1.Items.Add;
          ListItem.Caption := String(LocalHeader.Filename);
          ListItem.SubItems.Add(FormatDateTime('yyyy/mm/dd, hh:mm:ss',FileDateToDateTime(LocalHeader.DataTime)));
          ListItem.SubItems.Add(Inttostr(LocalHeader.OriSize));
          ListItem.SubItems.Add(inttostr(LocalHeader.CompressSize));
          ListItem.SubItems.Add(inttohex(LocalHeader.Crc,8));

          //goto next local header
          Seek(infile,FilePos(infile)+LocalHeader.CompressSize);


     end;

     CloseFile(infile);
end;

procedure TForm1.extractClick(Sender: TObject);
var
   CharIdent: array[0..3] of char;
   ComentSiz: Word;
begin
     Compressing := false;
     //Make the crc table
     Make_CrcTable;

     AssignFile(infile,'lzb.lfb');
     Reset(infile,1);
     //Read the main Header
     BlockRead(infile,CharIdent,4);
     if CharIdent <> HeaderIdentfy then
        begin
             MessageBox(Handle,'Not a valid LFB file','Error',MB_OK+MB_ICONERROR);
             Exit;
        end;
     BlockRead(infile,ComentSiz,2);
     if ComentSiz > 0 then Seek(Infile,FilePos(infile)+ComentSiz);
     While not Eof(infile) do
     begin
          //Size of header
          BlockRead(infile,LocalHeader.HeaderSig,4);
          //reseved
          BlockRead(infile,LocalHeader.Reserved1,2);
          //reserved
          BlockRead(infile,LocalHeader.Reserved2,2);
          //operating system
          BlockRead(infile,LocalHeader.OS,1);
          //compress method
          BlockRead(infile,LocalHeader.Method,1);
          //compressed size
          BlockRead(infile, LocalHeader.CompressSize,4);
          //original size
          BlockRead(infile,LocalHeader.OriSize,4);
          //file time
          BlockRead(infile,LocalHeader.DataTime,4);
          //file unpacked crc
          BlockRead(infile,LocalHeader.Crc,4);
          //filename size
          BlockRead(infile,LocalHeader.FilenameSize,2);
          //filename
          BlockRead(infile,LocalHeader.Filename,LocalHeader.FilenameSize);
          //Extended header size
          BlockRead(infile,LocalHeader.ExtHeaderSiz,2);
          while LocalHeader.ExtHeaderSiz <> 0 do
          begin
               Seek(infile,FilePos(infile)+LocalHeader.ExtHeaderSiz-2);
               BlockRead(infile,LocalHeader.ExtHeaderSiz,2);
          end;

          //AssignFile(outfile,ExtractFilePath(Paramstr(0))+ExtractFileName(String(LocalHeader.Filename)));
          AssignFile(outfile,'.\Compon\'+ExtractFileName(String(LocalHeader.Filename)));
          Rewrite(outfile,1);

          //extract
          CalCrc := CRC_MASK;
          BytesLeft :=  LocalHeader.CompressSize;
          Case LocalHeader.Method of
               0: UnStore;//stored
               1: DecompressFin; //FIN
               3: DecodeLzAri; //LzAri
          end;

          if LocalHeader.Crc = (CalCrc xor CRC_MASK) then
              Log.Items.Add('Crc Ok!!!')
          else Log.Items.Add('Crc ERROR!!!');

          CloseFile(Outfile);

     end;

     CloseFile(infile);
end;
end.
